/*
 * BitObfuscatorOutputStream.java
 * 
 * Created on Sep 23, 2007, 8:56:37 PM
 * 
 * 
 * 
 */
package info.heinzelnisse.he;

import java.io.IOException;
import java.io.OutputStream;

/**
 *
 * @author hklein
 */
public class BitObfuscatorOutputStream extends OutputStream {
    OutputStream os;
    
    public BitObfuscatorOutputStream(OutputStream os) {
        this.os = os;
    }

    public void write(int b) throws IOException {
        // switch some bits (1 and 8) of the byte containing the data
        int switch1_8 = ((b & 128) >> 7) + ((b & 1) << 7);
        b &= (255 - 128 - 1); // setting bit 8 and 1 to zero
        b |= switch1_8; // setting new 1 and 8
        os.write(b);
    }

    @Override
    public void close() throws IOException {
        if (os != null) {
            os.close();
        }
    }
}
