/*
 * TranslationGroup.java
 *
 * Created on February 20, 2007, 6:25 PM
 *
 */

package info.heinzelnisse.he;

import java.util.Collection;

/**
 *
 * Container to hold norwegian, german and mixed translations
 *
 * @author Heiko Klein
 */
public class TranslationGroup {
    private Collection<Translation> norwegianTranslation = null;
    private Collection<Translation> germanTranslation = null;
    private Collection<Translation> mixedTranslation = null;
    
    public TranslationGroup() {
    }
    
    public Collection<Translation> getNorwegianTranslation() {
        return norwegianTranslation;
    }
    
    public void setNorwegianTranslation(Collection<Translation> norwegianTranslation) {
        this.norwegianTranslation = norwegianTranslation;
    }

    public void addNorwegianTranslation(Collection<Translation> norwegianTranslation) {
        if (this.norwegianTranslation != null) {
            if (norwegianTranslation != null)
                this.norwegianTranslation.addAll(norwegianTranslation);
        } else {
            setNorwegianTranslation(norwegianTranslation);
        }
    }
    
    public Collection<Translation> getGermanTranslation() {
        return germanTranslation;
    }
    
    public void setGermanTranslation(Collection<Translation> germanTranslation) {
        this.germanTranslation = germanTranslation;
    }

    public void addGermanTranslation(Collection<Translation> germanTranslation) {
        if (this.germanTranslation != null) {
            if (germanTranslation != null)
                this.germanTranslation.addAll(germanTranslation);
        } else {
            setGermanTranslation(germanTranslation);
        }
    }
    
    public Collection<Translation> getMixedTranslation() {
        return mixedTranslation;
    }
    
    public void setMixedTranslation(Collection<Translation> mixedTranslation) {
        this.mixedTranslation = mixedTranslation;
    }
    public void addMixedTranslation(Collection<Translation> mixedTranslation) {
        if (this.mixedTranslation != null) {
            if (mixedTranslation != null) {
                this.mixedTranslation.addAll(mixedTranslation);
            }
        } else {
            setMixedTranslation(mixedTranslation);
        }
    }


    public long size() {
        long size = 0;
        if (getMixedTranslation() != null) size += getMixedTranslation().size();
        if (getGermanTranslation() != null) size += getGermanTranslation().size();
        if (getNorwegianTranslation() != null) size += getNorwegianTranslation().size();
        return size;
    }

    @Override
    public int hashCode() {
        return toString().hashCode();
    }
    @Override
    public boolean equals(Object o) {
        if (o == this) return true;
        if (o instanceof TranslationGroup) {
            TranslationGroup tg = (TranslationGroup)o;
            return toString().equals(tg.toString());
        }
        return false;
    }
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("");
        sb.append(collectionToString(norwegianTranslation));
        sb.append(collectionToString(germanTranslation));
        sb.append(collectionToString(mixedTranslation));
        return sb.toString();
    }
    private StringBuffer collectionToString(Collection<Translation> l) {
        StringBuffer sb = new StringBuffer("");
        if (l != null) {
            for (Translation t : l) {
                sb.append(t.toString());
                sb.append("\n");
            }
        }
        return sb;
    }
}
