/*
 * TranslationGroupTest.java
 * JUnit based test
 *
 * Created on September 7, 2007, 10:19 PM
 */

package info.heinzelnisse.he;

import java.util.ArrayList;
import junit.framework.*;

/**
 *
 * @author Heiko Klein
 */
public class TranslationGroupTest extends TestCase {
    
    public TranslationGroupTest(String testName) {
        super(testName);
    }

    protected void setUp() throws Exception {
        
    }

//    public void testGetNorwegianTranslation() {
//    }
//
//    public void testSetNorwegianTranslation() {
//    }
//
//    public void testGetGermanTranslation() {
//    }
//
//    public void testSetGermanTranslation() {
//    }
//
//    public void testGetMixedTranslation() {
//    }
//
//    public void testSetMixedTranslation() {
//    }

    public void testHashCode() {
        Translation t1 = Translation.getTranslationOf("wordNO\tarticleNO\toptionsNO\totherNO\twordDE\tarticleDE\toptionsDE\totherDE\tcategory", Translation.DE);
        Translation t2 = Translation.getTranslationOf("wordNO\tarticleNO\toptionsNO\totherNO\twordDE\tarticleDE\toptionsDE\totherDE\tcategory", Translation.DE);
        Translation t3 = Translation.getTranslationOf("XXwordNO\tarticleNO\toptionsNO\totherNO\twordDE\tarticleDE\toptionsDE\totherDE\tcategory", Translation.DE);
        assertTrue(t1.hashCode() == t2.hashCode());
        assertFalse(t1.hashCode() == t3.hashCode());
        TranslationGroup tg1 = new TranslationGroup();
        TranslationGroup tg2 = new TranslationGroup();
        TranslationGroup tg3 = new TranslationGroup();
        ArrayList<Translation> a1 = new ArrayList<Translation>();
        ArrayList<Translation> a2 = new ArrayList<Translation>();
        ArrayList<Translation> a3 = new ArrayList<Translation>();
        a1.add(t1);
        a2.add(t2);
        a3.add(t3);
        tg1.setNorwegianTranslation(a1);
        tg2.setNorwegianTranslation(a2);
        tg3.setNorwegianTranslation(a3);
        assertTrue(tg1.hashCode() == tg2.hashCode());
        assertFalse(tg1.hashCode() == tg3.hashCode());
        
    }

    public void testEquals() {
        Translation t1 = Translation.getTranslationOf("wordNO\tarticleNO\toptionsNO\totherNO\twordDE\tarticleDE\toptionsDE\totherDE\tcategory", Translation.DE);
        Translation t2 = Translation.getTranslationOf("wordNO\tarticleNO\toptionsNO\totherNO\twordDE\tarticleDE\toptionsDE\totherDE\tcategory", Translation.DE);
        Translation t3 = Translation.getTranslationOf("XXwordNO\tarticleNO\toptionsNO\totherNO\twordDE\tarticleDE\toptionsDE\totherDE\tcategory", Translation.DE);
        assertTrue(t1.equals(t1));
        assertTrue(t1.equals(t2));
        assertFalse(t1.equals(t3));
        TranslationGroup tg1 = new TranslationGroup();
        TranslationGroup tg2 = new TranslationGroup();
        TranslationGroup tg3 = new TranslationGroup();
        ArrayList<Translation> a1 = new ArrayList<Translation>();
        ArrayList<Translation> a2 = new ArrayList<Translation>();
        ArrayList<Translation> a3 = new ArrayList<Translation>();
        a1.add(t1);
        a2.add(t2);
        a3.add(t3);
        tg1.setNorwegianTranslation(a1);
        tg2.setNorwegianTranslation(a2);
        tg3.setNorwegianTranslation(a3);
        assertTrue(tg1.equals(tg1));
        assertTrue(tg1.equals(tg2));
        assertFalse(tg1.equals(tg3));
    }
    
}
